%global gem_name concurrent-ruby
Name:                rubygem-%{gem_name}
Version:             1.1.9
Release:             1
Summary:             Modern concurrency tools for Ruby
License:             MIT
URL:                 http://www.concurrent-ruby.com
Source0:             https://rubygems.org/gems/%{gem_name}-%{version}.gem
Source1:             https://github.com/ruby-concurrency/concurrent-ruby/archive/v%{version}.tar.gz
BuildRequires:       ruby(release) rubygems-devel ruby >= 1.9.3 rubygem(rspec) rubygem(timecop)
BuildArch:           noarch
%description
Modern concurrency tools including agents, futures, promises, thread pools,
actors, supervisors, and more.
Inspired by Erlang, Clojure, Go, JavaScript, actors, and classic concurrency
patterns.

%package doc
Summary:             Documentation for %{name}
Requires:            %{name} = %{version}-%{release}
BuildArch:           noarch
%description doc
Documentation for %{name}.

%prep
%setup -q -n %{gem_name}-%{version}

%build
gem build ../%{gem_name}-%{version}.gemspec
%gem_install

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/

%check
pushd .%{gem_instdir}
tar xzf %{SOURCE1}
ln -s %{gem_name}-%{version}/spec spec
sed -i '/require.*concurrent-edge/ s/^/#/' spec/spec_helper.rb
sed -i '/allow_c_extensions?/,/^      end/ s/^/#/' spec/concurrent/atomic/atomic_reference_spec.rb
RUBYOPT=-Ilib/concurrent-ruby rspec -rspec_helper \
  -fd \
  --exclude-pattern 'spec/concurrent/{actor_spec.rb,channel_spec.rb,lazy_register_spec.rb,channel/**/*,edge/**/*,promises_spec.rb,throttle_spec.rb,cancellation_spec.rb,scheduled_task_spec.rb,timer_task_spec.rb,executor/wrapping_executor_spec.rb}' \
  spec

popd

%files
%dir %{gem_instdir}
%license %{gem_instdir}/LICENSE.txt
%exclude %{gem_instdir}/ext
%{gem_libdir}
%exclude %{gem_cache}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/CHANGELOG.md
%{gem_instdir}/Gemfile
%doc %{gem_instdir}/README.md
%{gem_instdir}/Rakefile

%changelog
* Tue Jul 19 2022 liyanan <liyanan32@h-partners.com> - 1.1.9-1
- update to 1.1.9

* Tue Sep 8 2020 yanan li <liyanan032@huawei.com> - 1.0.5-2
- fix build fail

* Tue Aug 18 2020 wanglin <wanglin175@huawei.com> - 1.0.5-1
- package init
